require 'erb'

module Contraption
  class Formatter
    def initialize location
      @source = location
      find_formats
    end

    def format context, method=nil
      renderer(method || context.type).result binding
    end

    def formats
      @formats.keys
    end

    private
    def find_formats
      @formats = @source.list('.erb')
                        .inject({}){|collection, f| collection[f.split('.').first.to_sym] = f; collection}
    end

    def renderer type
      ERB.new @source.read(
        @formats.fetch(type){ raise ArgumentError, "#{type} is not a valid format" }
      )
    end
  end
end
