module Contraption
  class Generator
    def initialize args
      @options = args
    end

    def run!
      directories = ['drafts', 'posts']
      directories.each do |d|
        destination.cd d
      end

      init_git
      copy_example_files
      make_initial_commit
    end

    private
    def destination
      @options.destination
    end

    def init_git
      `git init #{destination.path}`
    end

    def copy_example_files
      `cp -r data/* #{destination.path}`
    end

    def make_initial_commit
      `cd #{destination.path}; git add --all .; git commit -m 'Generated input for Contraption static site generator'`
    end
  end
end
