require_relative 'orchestrator'

module Contraption
  class Previewer < Orchestrator
    PORT = 9009

    def post_run
      trap("INT") { cleanup }
      spawn_server
    end

    private
    def source
      @source ||= Repository.new(@options.source).clone
    end

    def cleanup
      puts "\nremoving temporary files and shutting down server"
      source.destroy
      site.location.destroy
    end

    def spawn_server
      puts "Previewing site on http://localhost:#{PORT}"
      `ruby -run -e httpd #{site.root} -p #{PORT} &> /dev/null`
    end
  end
end
