require_relative 'orchestrator'
require_relative 's3_uploader'

module Contraption
  class Runner < Orchestrator
    def initialize options
      @options = options
    end

    private
    def source
      @source ||= Repository.new @options.source
    end

    def handlers
      h = super
      if @options.s3_access_key_id
        h <<
          S3Uploader.new({access_key_id: @options.s3_access_key_id,
                          secret_access_key: @options.s3_secret_access_key},
                          @options.s3_target_bucket,
                          @options.source)
      end
      h
    end
  end
end
