module Contraption
  class TagCloud
    def initialize posts
      @posts = posts
    end

    def to_s
      @posts.by_tag
            .each_pair
            .map {|k, v| [tag_link(k), tag_size(v.length)]}
            .map {|el| scale el}
            .join "\n"
    end

    private
    def tag_link tag
      tag = Tag.new tag
      %Q{<a class="indivisible" href="tags/#{tag.to_url}/index.html">#{tag.to_s}</a>}
    end

    def scale element
      link = element.first
      size = element.last
      %Q{<span style="font-size: #{size}em;">#{link}</span>}
    end

    def max
      @posts.by_tag.each_pair.map {|k, v| v.length}.max
    end

    def tag_size length
      (1 + length.to_f/max) * 0.8
    end
  end
end
